unit Unit1;

{                                                               .
       A simple countdown program                               .
                                                                .
       - It would be nice to fall in sleep while                .
         your mp3 player plays your favorite songs..            .
       - Without worrying if your computer has                  .
         shut-down and power-off                                .
                                                                .
       This program countdowns the given time in minutes.       .
       It calculates the spent-time in milliseconds             .
       at 0.1 sec. intervals.                                   .
       When given minutes (time) have elapsed,                  .
       SHUTDOWN and POWEROFF processes begin.                   .
       This module has a timing error upto ca. 100+ millisec.   .
       (timer1's interval plus the time needed for              .
       subroutine callings). Higher intervals=higher error rate;.
       smaller intervals=smaller error rate but higher cpu usage.
                                                                .
       Tested on win98-se .                                     .
                                                                .
       You should recompile and examine win-api's help          .
       for NT, win2000...                                       .
       (There you may find some privilege information on using  .
       system functions as "ExitWindowsEx" etc.)                .
                                                                .
                                                                .
                                                                .
       Notes :                                                  .
                                                                .
       1. A "soft" shutdown is performed; some                  .
       applications or tasks need to "query"                    .
       to close...So I do NOT advice the use of                 .
       EWX_FORCE parameter...                                   .
                                                                .
       2. All applications are being closed after the           .
       shutdown process begins. If a running                    .
       application needs to close some files                    .
       say; -that are changed or edited,                        .
       user may be asked to save..                              .
       (so the shutdown process stops and waits for user input; .
       the worst thing which we never want to happen)           .
                                                                .
       3. This module should be used only                       .
       when the system does't need any reply from               .
       the user prior to shutdown..                             .
       ("ExitWindowsEx" skips the final query :                 .
          "Close Window$ Session" dialog box)                   .
                                                                .
       4. For "POWEROFF" your computer must support this feature.
          (If not, only "Exit Window$" is performed.)           .
                                                                .
       5. Verdana font is used. Since "parent font = true" for  .
       all visible components that have caption/text property,  .
       you may click on the form and                            .
       change the font properties. All components' font attrib. .
       will be changed. You may also wish to change the         .
       "Charset" property.                                      .
                                                                .
       6. You may test this program with lines marked           .
          (*1*) and (*2*) are remarked (f.ex. // at the         .
          beginning each line).                                 .
                                                                .
                                                                .
                                                                .
       Test :                                                   .
                                                                .
       I have tested with conditions below :                    .
       Win98-se (turkish), 128MB ram,                           .
       winamp running and playing,                              .
       this program (count-down) is running..                   .
       Delphi can trigger problems.. So close it before running .
       count-down ! Save your works; and leave your desktop     .
       as "clean" as possible ....                              .
       I didn't test while screen-saver running.. Maybe it's    .
       better to turn s.saver off..                             .
                                                                .
       After several bootings.. Everything seems to             .
       work well..                                              .
       Program is in Turkish.. But.. You may replace the        .
       components' hint property with their caption etc.        .
       So check their hints while running!                      .
----------------------------------------------------------------.
       Usage :                                                  .
                                                                .
       Save all your works.                                     .
       Close all apps. that you don't need.                     .
       Run winamp, sonique etc.                                 .
       or similar mp3-player, start player, while               .
       listening to your favorite songs, run this program       .
       (count-down), input a time, f.ex. 45 mins., press the    .
       "Start count down" button, then,                         .
       turn off your monitor (you won't spend electric;         .
       would you?), adjust your loud-speakers' volume           .
       (no need to disturb your neighbours), and...go to bed .. .
       (have a rest; enough programming for tonight!!)          .
       Enjoy!  :0)                                              .
----------------------------------------------------------------.
       Warning :                                                .
         not to be used in                                      .
             Mission Critical or                                .
             Time Critical  conditions...                       .
             (since window$ itself is not at all!!)             .
----------------------------------------------------------------.
                                                                .
       Have fun                                                 .
                                                                .
       Use at your own risk                                     .
       (this remark is like a tradition; sorry..... ).          .
                                                                .
                                                                .
       Tuncay zgr - Ankara                                    .
       16.09.2001                                               .
                                                                .
                                                                .
       I'll be more than happy to hear from you;                .
       for any comment, trouble etc. please contact me :        .
       tuncay.ozgur@isbank.net.tr                               .
                                                                .
----------------------------------------------------------------.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Timer1: TTimer;
    SpeedButton2: TSpeedButton;
    ProgressBar1: TProgressBar;
    Label2: TLabel;
    Label4: TLabel;
    DAKLabel: TLabel;
    SANLabel: TLabel;
    Label7: TLabel;
    Bevel1: TBevel;
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Tick_1 : Dword; //integer;
    KapanisSuresi : integer; //milisaniye
                             //time to shutdown in milliseconds
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
   Timer1.Enabled := false;
   SpeedButton2.Enabled := false;
   SpeedButton1.Enabled := true;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
   if edit1.text='' then exit;
   TRY
     KapanisSuresi := StrToInt(edit1.text) * 60 * 1000;//milisaniye
           //ka milisaniye sonra kapanacan hesapla

           //calculate time to shutdown in milliseconds
   EXCEPT
     //geersiz karakter girilirse, ilemi iptal et..
     //programc, "exit" ncesi mesaj vermek isterse,
     //bu alana kod yazmaldr..

     //in case of erroneous input, break the process..
     //if the programmer wishes to give a message prior to "exit"
     //he/she should write code here..
     exit;
   END;

   Timer1.Enabled := true;
   Tick_1 := GetTickCount;
   SpeedButton1.Enabled := false;
   SpeedButton2.Enabled := true;
   ProgressBar1.Max := KapanisSuresi;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
   //kullanc rakam ve kontrol karakteri dnda birey girmesin
   //Hatrlatrm; Ctrl-V kontrol edilmedi

   //prevent user from input chars. other than numbers and ctrl.chars.
   //Let me remind that; Ctrl-V is not controlled..
   if Key in ['0'..'9'] then exit;
   if Key < #30 then exit;
   Key :=#0;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Fark, Sure : integer;
    Dak : integer;
begin
  //
  Sure := GetTickCount - Tick_1;//geen sre : milisaniye
                                //time elapsed : msec.
  ProgressBar1.Position := Sure;

  Fark := round((KapanisSuresi - Sure) / 1000);
  if Fark<0 then Fark :=0; //  :0)

  Dak := Fark div 60; // kalan dakikay hesapla
                      // calculate remaining minute(s)

  DAKlabel.caption := IntToStr(Dak);
  SANlabel.caption := ': '+ IntToStr(Fark - Dak * 60);

  if Fark = 0 then //zaman doldu..
                   //time is up..
  begin
     SpeedButton2Click(nil);
     label4.caption:='* Kapan lemleri Balad *'+#13+
                     '  (Shut-down in progress)'   ;
     label4.Font.Color := clRED;
     ProgressBar1.Position := ProgressBar1.Max;
(*1*) ExitWindowsEx(EWX_SHUTDOWN or {EWX_FORCE or} EWX_POWEROFF, 0);
                              {EWX_FORCE kullanmak gvenli deil}
                              {it is not safe to use EWX_FORCE}

(*2*) close; //gerekmiyor; programcya ilemlerin
             //artk bittiini gstermek iin...
             //
             //not needed; to show the programmer
             //that program is ended here...
  end;
end;

end.
